--------------------------------------------------------------------------------
-- Tooltip                                                                    --
--------------------------------------------------------------------------------
local _, ADDON = ...                                 --Includes all functions and variables
local my = UnitName("player")--player name

--(All credit for this func goes to Tekkub and his picoGuild!)
function ADDON:GetTipAnchor(frame)                   --although used with dropdownmenu
	local x, y = frame:GetCenter()
	if not x or not y then return 'TOPLEFT', 'BOTTOMLEFT' end
	local hhalf = (x > UIParent:GetWidth() * 2 / 3) and 'RIGHT' or (x < UIParent:GetWidth() / 3) and 'LEFT' or ''
	local vhalf = (y > UIParent:GetHeight() / 2) and 'TOP' or 'BOTTOM'
	return vhalf..hhalf, frame, (vhalf == 'TOP' and 'BOTTOM' or 'TOP')..hhalf
end
function ADDON:GetTipAnchor2(frame)
	local x, y = frame:GetCenter()
	local hhalf = (x > UIParent:GetWidth() / 2) and 'RIGHT' or (x < UIParent:GetWidth() / 2) and 'LEFT' or ''
	local vhalf = (y > UIParent:GetHeight() / 2) and 'TOP' or 'BOTTOM'
	return vhalf..hhalf, frame, (vhalf == 'TOP' and 'BOTTOM' or 'TOP')..(hhalf == 'RIGHT' and 'LEFT' or 'Right')
end
--Main Tooltip
function ADDON:tooltip(tooltip)
	tooltip:AddLine(ADDON.L["professions"])
	if (ADDON:tcount({GetProfessions()})>0 and ADDON.save[my].config.tooltip.showskills) then
		for _,index in pairs({GetProfessions()}) do
			if index then
				local name, texture, rank, maxRank, numSpells, spelloffset, skillLine = GetProfessionInfo(index)
				tooltip:AddDoubleLine(name,rank.."/"..maxRank,1,1,1,0,1,0)
				tooltip:AddTexture(texture)
			end
		end
		--Pick Look
		local name,_,icon,_ = GetSpellInfo(1804)
		if GetSpellBookItemInfo(name) then
			tooltip:AddDoubleLine(name,UnitLevel("player")*5,1,1,1,0,1,0)
			tooltip:AddTexture(icon)
		end
	end
	--Cooldowns
	if (ADDON.save[my].config.tooltip.showcds == true) then
		local jj = nil
		local duration = 0
		jj = nil
		tooltip:AddLine(" ")
		tooltip:AddLine(ADDON.L["cds"])
		for k,v in ADDON:pairsByKeys(ADDON.save[my].cds) do
			duration = difftime(v,time())
			if duration>0 then
				jj=true
				tooltip:AddDoubleLine("|cff00ff00"..k.."|r",SecondsToTime(duration),1,1,1,1,0,0)
			end
		end
		for k,v in ADDON:pairsByKeys(ADDON.save) do
			if k~=my and v.cds~=nil and (ADDON.save[my].config.bothfactions or v.faction==UnitFactionGroup("player")) then
				for kk,vv in ADDON:pairsByKeys(v.cds) do
					duration = difftime(vv,time())
					if duration>0 then
						jj=true
						tooltip:AddDoubleLine("["..k.."] "..kk,SecondsToTime(duration),1,1,1,1,0,0)
					end
				end
			end
		end
		if not jj then tooltip:AddLine(ADDON.L["nocds"],0,1,0) end
	end
	--Infos
	if (ADDON.save[my].config.tooltip.showbuttons == true) then
		tooltip:AddLine(" ")
		for _,key in pairs(ADDON.keys) do
			local text
			local id = ADDON.save[my].quicklaunch[key.Key]
			if (id==-1 and ADDON.save[my].lastprofession>0) then
				text = "*"..GetSpellInfo(ADDON.save[my].lastprofession).."*"
			elseif (id=='menu') then
				text = ADDON.L["openmenu"]
			elseif (id=='fav') then
				text = ADDON.L["favorites"]
			elseif (id>0) then
				text = GetSpellInfo(id)
			end
			if (text and key.Mod) then
				tooltip:AddDoubleLine(key.Mod..' + '..key.Button, "|cffffffff"..text.."|r")
			elseif (text) then
				tooltip:AddDoubleLine(key.Button, "|cffffffff"..text.."|r")
			end
		end
	end
end